OGRE-Next: Ogre::UnifiedHighLevelGpuProgram Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Member Functions | List of all members
Ogre::UnifiedHighLevelGpuProgram Class Reference
Core » Resources

Specialisation of HighLevelGpuProgram which just delegates its implementation to one other high level program, allowing a single program definition to represent one supported program from a number of options. More...

`#include <OgreUnifiedHighLevelGpuProgram.h>`

Inheritance diagram for Ogre::UnifiedHighLevelGpuProgram:
[legend]

## Classes
class | CmdDelegate
| Command object for setting delegate (can set more than once) More...

## Public Member Functions
| UnifiedHighLevelGpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, should be used only by factory classes.
| ~UnifiedHighLevelGpuProgram () override
GpuProgram * | _getBindingDelegate () override
| Returns the GpuProgram which should be bound to the pipeline.
const HighLevelGpuProgramPtr & | _getDelegate () const
| Get the chosen delegate.
void | addDelegateProgram (const String &name)
| Adds a new delegate program to the list.
void | addListener (Listener *lis) override
| Register a listener on this resource.
size_t | calculateSize () const override
| Calculate the size of a resource; this will only be called after 'load'.
void | clearDelegatePrograms ()
| Remove all delegate programs.
GpuProgramParametersSharedPtr | createParameters () override
| Creates a new parameters object compatible with this program definition.
void | escalateLoading () override
| Escalates the loading of a background loaded resource.
GpuProgramParametersSharedPtr | getDefaultParameters () override
| Get a reference to the default parameters which are to be used for all uses of this program.
const String & | getLanguage () const override
| Returns a string that specifies the language of the gpu programs as specified in a material script.
LoadingState | getLoadingState () const override
| Returns the current loading state.
ushort | getNumberOfPosesIncluded () const override
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.
bool | getPassFogStates () const override
| Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override)
bool | getPassSurfaceAndLightStates () const override
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override)
bool | getPassTransformStates () const override
| Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.
size_t | getSize () const override
| Retrieves info about the size of the resource.
bool | hasCompileError () const override
| Did this program encounter a compile error when loading?
bool | hasDefaultParameters () const override
| Returns true if default parameters have been set up.
bool | isBackgroundLoaded () const override
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded () const override
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const override
| Returns whether the resource is currently in the process of background loading.
bool | isMorphAnimationIncluded () const override
| Returns whether a vertex program includes the required instructions to perform morph animation.
bool | isPoseAnimationIncluded () const override
| Returns whether a vertex program includes the required instructions to perform pose animation.
bool | isReloadable () const override
| Returns true if the Resource is reloadable, false otherwise.
bool | isSkeletalAnimationIncluded () const override
| Returns whether a vertex program includes the required instructions to perform skeletal animation.
bool | isSupported () const override
| Returns whether this program can be supported on the current renderer and hardware.
bool | isVertexTextureFetchRequired () const override
| Returns whether this vertex program requires support for vertex texture fetch from the hardware.
void | load (bool backgroundThread=false) override
| Loads the resource, if it is not already.
void | reload (LoadingFlags flags=LF_DEFAULT) override
| Reloads the resource, if it is already loaded.
void | removeListener (Listener *lis) override
| Remove a listener on this resource.
void | resetCompileError () override
| Reset a compile error if it occurred, allowing the load to be retried.
void | setBackgroundLoaded (bool bl) override
| Tells the resource whether it is background loaded or not.
void | touch () override
| 'Touches' the resource to indicate it has been used.
void | unload () override
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::HighLevelGpuProgram
| HighLevelGpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, should be used only by factory classes.
| ~HighLevelGpuProgram () override
const GpuNamedConstants & | getConstantDefinitions () const override
| Get the full list of GpuConstantDefinition instances.
bool | getEnableIncludeHeader () const
bool | getUseHlmsParser () const
void | setEnableIncludeHeader (bool bEnable)
| Whether we should parse the source code looking for include files and embedding the file.
void | setUseHlmsParser (bool bUse)
| Whether we should run the shader through the Hlms parser.
Public Member Functions inherited from Ogre::GpuProgram
| GpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| ~GpuProgram () override
bool | getBuildParametersFromReflection () const
virtual Vector3 | getComputeGroupDimensions () const
| Returns the number of process groups dispatched by this compute program.
virtual const String & | getManualNamedConstantsFile () const
| Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
uint8 | getNumClipDistances () const
| Retrieves the number of clip distances. See GpuProgram::setNumClipDistances.
virtual const String & | getSource () const
| Gets the assembler source for this program.
virtual const String & | getSourceFile () const
| Gets the name of the file used as source for this program.
virtual const String & | getSyntaxCode () const
| Gets the syntax code for this program e.g.
virtual GpuProgramType | getType () const
| Get the program type.
virtual bool | isAdjacencyInfoRequired () const
| Returns whether this geometry program requires adjacency information from the input primitives.
virtual bool | isVpAndRtArrayIndexFromAnyShaderRequired () const
| Returns whether this program requires support for choosing viewport or render target index in any program or only geometry one.
virtual void | setAdjacencyInfoRequired (bool r)
| Sets whether this geometry program requires adjacency information from the input primitives.
virtual void | setAutoReflectArrayBindingsInRootLayout (bool bReflectArrayRootLayouts)
| Set to true to reflects the shader looking for array bindings (e.g.
void | setBuildParametersFromReflection (bool buildParams)
virtual void | setComputeGroupDimensions (Vector3 dimensions)
| Sets the number of process groups dispatched by this compute program.
virtual void | setManualNamedConstants (const GpuNamedConstants &namedConstants)
| Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.
virtual void | setManualNamedConstantsFile (const String &paramDefFile)
| Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform morph animation.
void | setNumClipDistances (const uint8 numClipDistances)
| Sets the number of clip distances this shader uses.
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program includes the required instructions to perform pose animation.
void | setPrefabRootLayout (const PrefabRootLayout::PrefabRootLayout &prefab)
| Sets a prefab root layout, mostly meant for low level materials (e.g.
virtual void | setReplaceVersionMacro (bool bReplace)
| When true:
virtual void | setRootLayout (GpuProgramType t, const RootLayout &rootLayout)
| Sets a RootLayout programmatically, thus the shader source won't be parsed looking for one We will call validate()
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program includes the required instructions to perform skeletal animation.
virtual void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string.
virtual void | setSource (const String &source, const String &debugFilename)
| Sets the source assembly for this program from an in-memory string, while providing a path to a file, which can be needed/useful for debugging shaders (i.e.
virtual void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program.
virtual void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g.
virtual void | setType (GpuProgramType t)
| Set the program type (only valid before load)
virtual void | setUniformBlockBinding (const char *blockName, uint32 bindingSlot)
| For GL only. Program must be bound when calling.
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware.
virtual void | setVpAndRtArrayIndexFromAnyShaderRequired (bool r)
| Sets whether this program requires support for choosing viewport or render target index in any program or only geometry one.
virtual void | unsetRootLayout ()
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete ()
| Firing of unloading complete event.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual ResourceManager * | getCreator ()
| Gets the manager which created this resource.
virtual const String & | getGroup () const
| Gets the group which this resource is a member of.
virtual ResourceHandle | getHandle () const
virtual const String & | getName () const
| Gets resource name.
virtual const String & | getOrigin () const
| Get the origin of this resource, e.g.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual bool | isManuallyLoaded () const
| Is this resource manually loaded?
virtual bool | isPrepared () const
| Returns true if the Resource has been prepared, false otherwise.
bool | markForReload ()
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?".
virtual void | setToLoaded ()
| Change the Resource loading state to loaded.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Static Public Member Functions
static int | getPriority (String shaderLanguage)
static void | setPrioriry (String shaderLanguage, int priority)
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Additional Inherited Members
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 , LF_MARKED_FOR_RELOAD = 8 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING , LOADSTATE_UNLOADED_MARKED_FOR_RELOAD }
| Enum identifying the loading state of the resource. More...
Public Attributes inherited from Ogre::Resource
| OGRE_AUTO_MUTEX
Static Public Attributes inherited from Ogre::HighLevelGpuProgram
static CmdEnableIncludeHeader | msEnableIncludeHeaderCmd
static CmdUseHlmsParser | msUseHlmsParser

## Detailed Description

Specialisation of HighLevelGpuProgram which just delegates its implementation to one other high level program, allowing a single program definition to represent one supported program from a number of options.

Remarks
  Whilst you can use Technique to implement several ways to render an object depending on hardware support, if the only reason to need multiple paths is because of the high-level shader language supported, this can be cumbersome. For example you might want to implement the same shader in HLSL and GLSL for portability but apart from the implementation detail, the shaders do the same thing and take the same parameters. If the materials in question are complex, duplicating the techniques just to switch language is not optimal, so instead you can define high-level programs with a syntax of 'unified', and list the actual implementations in order of preference via repeated use of the 'delegate' parameter, which just points at another program name. The first one which has a supported syntax will be used.

## Constructor & Destructor Documentation

## ◆ UnifiedHighLevelGpuProgram()

Ogre::UnifiedHighLevelGpuProgram::UnifiedHighLevelGpuProgram | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Constructor, should be used only by factory classes.

## ◆ ~UnifiedHighLevelGpuProgram()

Ogre::UnifiedHighLevelGpuProgram::~UnifiedHighLevelGpuProgram | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getBindingDelegate()

GpuProgram * Ogre::UnifiedHighLevelGpuProgram::_getBindingDelegate | ( |  | ) |
| overridevirtual

Returns the GpuProgram which should be bound to the pipeline.

Remarks
  This method is simply to allow some subclasses of GpuProgram to delegate the program which is bound to the pipeline to a delegate, if required.

Reimplemented from Ogre::HighLevelGpuProgram.

## ◆ _getDelegate()

const HighLevelGpuProgramPtr & Ogre::UnifiedHighLevelGpuProgram::_getDelegate | ( |  | ) | const

Get the chosen delegate.

## ◆ addDelegateProgram()

void Ogre::UnifiedHighLevelGpuProgram::addDelegateProgram | ( | const String & | name | ) |

Adds a new delegate program to the list.

Remarks
  Delegates are tested in order so earlier ones are preferred.

## ◆ addListener()

void Ogre::UnifiedHighLevelGpuProgram::addListener | ( | Listener * | lis | ) |
| overridevirtual

Register a listener on this resource.

See also
  Resource::Listener

Reimplemented from Ogre::Resource.

## ◆ calculateSize()

size_t Ogre::UnifiedHighLevelGpuProgram::calculateSize | ( |  | ) | const
| overridevirtual

Calculate the size of a resource; this will only be called after 'load'.

Reimplemented from Ogre::HighLevelGpuProgram.

## ◆ clearDelegatePrograms()

void Ogre::UnifiedHighLevelGpuProgram::clearDelegatePrograms | ( |  | ) |

Remove all delegate programs.

## ◆ createParameters()

GpuProgramParametersSharedPtr Ogre::UnifiedHighLevelGpuProgram::createParameters | ( |  | ) |
| overridevirtual

Creates a new parameters object compatible with this program definition.

Remarks
  Unlike low-level assembly programs, parameters objects are specific to the program and therefore must be created from it rather than by the HighLevelGpuProgramManager. This method creates a new instance of a parameters object containing the definition of the parameters this program understands.

Reimplemented from Ogre::HighLevelGpuProgram.

## ◆ escalateLoading()

void Ogre::UnifiedHighLevelGpuProgram::escalateLoading | ( |  | ) |
| overridevirtual

Escalates the loading of a background loaded resource.

Remarks
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented from Ogre::Resource.

## ◆ getDefaultParameters()

GpuProgramParametersSharedPtr Ogre::UnifiedHighLevelGpuProgram::getDefaultParameters | ( |  | ) |
| overridevirtual

Get a reference to the default parameters which are to be used for all uses of this program.

Remarks
  A program can be set up with a list of default parameters, which can save time when using a program many times in a material with roughly the same settings. By retrieving the default parameters and populating it with the most used options, any new parameter objects created from this program afterwards will automatically include the default parameters; thus users of the program need only change the parameters which are unique to their own usage of the program.

Reimplemented from Ogre::GpuProgram.

## ◆ getLanguage()

const String & Ogre::UnifiedHighLevelGpuProgram::getLanguage | ( |  | ) | const
| overridevirtual

Returns a string that specifies the language of the gpu programs as specified in a material script.

ie: asm, cg, hlsl, glsl

Reimplemented from Ogre::GpuProgram.

## ◆ getLoadingState()

LoadingState Ogre::UnifiedHighLevelGpuProgram::getLoadingState | ( |  | ) | const
| overridevirtual

Returns the current loading state.

Reimplemented from Ogre::Resource.

## ◆ getNumberOfPosesIncluded()

ushort Ogre::UnifiedHighLevelGpuProgram::getNumberOfPosesIncluded | ( |  | ) | const
| overridevirtual

Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.

Reimplemented from Ogre::GpuProgram.

## ◆ getPassFogStates()

bool Ogre::UnifiedHighLevelGpuProgram::getPassFogStates | ( |  | ) | const
| overridevirtual

Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override)

Remarks
  On DirectX, shader model 2 and earlier continues to have fixed-function fog applied to it, so fog state is still passed (you should disable fog on the pass if you want to perform fog in the shader). In OpenGL it is also common to be able to access the fixed-function fog state inside the shader.

Reimplemented from Ogre::GpuProgram.

## ◆ getPassSurfaceAndLightStates()

bool Ogre::UnifiedHighLevelGpuProgram::getPassSurfaceAndLightStates | ( |  | ) | const
| overridevirtual

Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override)

Remarks
  Most vertex programs do not need this material information, however GLSL shaders can refer to this material and lighting state so enable this option

Reimplemented from Ogre::GpuProgram.

## ◆ getPassTransformStates()

bool Ogre::UnifiedHighLevelGpuProgram::getPassTransformStates | ( |  | ) | const
| overridevirtual

Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.

Remarks
  Most vertex programs do not need fixed-function transform information, however GLSL shaders can refer to this state so enable this option

Reimplemented from Ogre::GpuProgram.

## ◆ getPriority()

static int Ogre::UnifiedHighLevelGpuProgram::getPriority | ( | String | shaderLanguage | ) |
| static

## ◆ getSize()

size_t Ogre::UnifiedHighLevelGpuProgram::getSize | ( |  | ) | const
| overridevirtual

Retrieves info about the size of the resource.

Reimplemented from Ogre::Resource.

## ◆ hasCompileError()

bool Ogre::UnifiedHighLevelGpuProgram::hasCompileError | ( |  | ) | const
| overridevirtual

Did this program encounter a compile error when loading?

Reimplemented from Ogre::GpuProgram.

## ◆ hasDefaultParameters()

bool Ogre::UnifiedHighLevelGpuProgram::hasDefaultParameters | ( |  | ) | const
| overridevirtual

Returns true if default parameters have been set up.

Reimplemented from Ogre::GpuProgram.

## ◆ isBackgroundLoaded()

bool Ogre::UnifiedHighLevelGpuProgram::isBackgroundLoaded | ( |  | ) | const
| overridevirtual

Returns whether this Resource has been earmarked for background loading.

Remarks
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented from Ogre::Resource.

## ◆ isLoaded()

bool Ogre::UnifiedHighLevelGpuProgram::isLoaded | ( |  | ) | const
| overridevirtual

Returns true if the Resource has been loaded, false otherwise.

Reimplemented from Ogre::Resource.

## ◆ isLoading()

bool Ogre::UnifiedHighLevelGpuProgram::isLoading | ( |  | ) | const
| overridevirtual

Returns whether the resource is currently in the process of background loading.

Reimplemented from Ogre::Resource.

## ◆ isMorphAnimationIncluded()

bool Ogre::UnifiedHighLevelGpuProgram::isMorphAnimationIncluded | ( |  | ) | const
| overridevirtual

Returns whether a vertex program includes the required instructions to perform morph animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

Reimplemented from Ogre::GpuProgram.

## ◆ isPoseAnimationIncluded()

bool Ogre::UnifiedHighLevelGpuProgram::isPoseAnimationIncluded | ( |  | ) | const
| overridevirtual

Returns whether a vertex program includes the required instructions to perform pose animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Reimplemented from Ogre::GpuProgram.

## ◆ isReloadable()

bool Ogre::UnifiedHighLevelGpuProgram::isReloadable | ( |  | ) | const
| overridevirtual

Returns true if the Resource is reloadable, false otherwise.

Reimplemented from Ogre::Resource.

## ◆ isSkeletalAnimationIncluded()

bool Ogre::UnifiedHighLevelGpuProgram::isSkeletalAnimationIncluded | ( |  | ) | const
| overridevirtual

Returns whether a vertex program includes the required instructions to perform skeletal animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

Reimplemented from Ogre::GpuProgram.

## ◆ isSupported()

bool Ogre::UnifiedHighLevelGpuProgram::isSupported | ( |  | ) | const
| overridevirtual

Returns whether this program can be supported on the current renderer and hardware.

Reimplemented from Ogre::GpuProgram.

## ◆ isVertexTextureFetchRequired()

bool Ogre::UnifiedHighLevelGpuProgram::isVertexTextureFetchRequired | ( |  | ) | const
| overridevirtual

Returns whether this vertex program requires support for vertex texture fetch from the hardware.

Reimplemented from Ogre::GpuProgram.

## ◆ load()

void Ogre::UnifiedHighLevelGpuProgram::load | ( | bool | backgroundThread = false | ) |
| overridevirtual

Loads the resource, if it is not already.

Remarks
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters

  backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented from Ogre::Resource.

## ◆ reload()

void Ogre::UnifiedHighLevelGpuProgram::reload | ( | LoadingFlags | flags = LF_DEFAULT | ) |
| overridevirtual

Reloads the resource, if it is already loaded.

Remarks
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented from Ogre::Resource.

References Ogre::Resource::LF_DEFAULT.

## ◆ removeListener()

void Ogre::UnifiedHighLevelGpuProgram::removeListener | ( | Listener * | lis | ) |
| overridevirtual

Remove a listener on this resource.

See also
  Resource::Listener

Reimplemented from Ogre::Resource.

## ◆ resetCompileError()

void Ogre::UnifiedHighLevelGpuProgram::resetCompileError | ( |  | ) |
| overridevirtual

Reset a compile error if it occurred, allowing the load to be retried.

Reimplemented from Ogre::GpuProgram.

## ◆ setBackgroundLoaded()

void Ogre::UnifiedHighLevelGpuProgram::setBackgroundLoaded | ( | bool | bl | ) |
| overridevirtual

Tells the resource whether it is background loaded or not.

Remarks

See also
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented from Ogre::Resource.

## ◆ setPrioriry()

static void Ogre::UnifiedHighLevelGpuProgram::setPrioriry | ( | String | shaderLanguage,
|  | int | priority )
| static

## ◆ touch()

void Ogre::UnifiedHighLevelGpuProgram::touch | ( |  | ) |
| overridevirtual

'Touches' the resource to indicate it has been used.

Reimplemented from Ogre::Resource.

## ◆ unload()

void Ogre::UnifiedHighLevelGpuProgram::unload | ( |  | ) |
| overridevirtual

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented from Ogre::Resource.

The documentation for this class was generated from the following file:

- OgreUnifiedHighLevelGpuProgram.h